<template>
  <v-container>
    <v-form ref="reasurorFilterForm" fast-fail @submit.prevent="submitForm" class="custom">
      <v-row style="margin-left: 15px">
        <v-col class="v-col" cols="12" md="1">
          <v-checkbox v-model="this.treteSelected" label-position="left" color="success" hide-details>
            <span style="margin-left: 10px;">Trete</span>
          </v-checkbox>
        </v-col>
        <v-col class="v-col" cols="12" md="2">
          <v-checkbox v-model="this.ihtiyariSelected" label-position="left" color="success" hide-details>
            <span style="margin-left: 10px;">İhtiyari</span>
          </v-checkbox>
        </v-col>
      </v-row>
      <v-row v-if="treteSelected">
        <v-col>
          <div class="custom-label">İşlem Tipi </div><br>
          <v-combobox class="custom-combobox" :items="this.banks" v-model="reactTreteForm.selectedProcessType"
            variant="outlined" />
          <div class="custom-label">Reasürör Şirket</div><br>
          <v-combobox class="custom-combobox" :items="this.reasurorCompanys"
            v-model="reactTreteForm.selectedReasurorCompany" variant="outlined" />
        </v-col>
        <v-col>
          <div class="custom-label">Yıl </div><br>
          <v-text-field class="text-eureko" :disabled="false" variant="outlined" v-model="reactTreteForm.year"
            type="number" />
          <div class="custom-label">Quarter</div><br>
          <v-combobox class="custom-combobox" :items="this.quarters" v-model="reactTreteForm.selectedQuarter"
            variant="outlined" />
        </v-col>
        <v-col>
          <div class="custom-label">Döviz</div><br>
          <v-combobox class="custom-combobox" :items="this.currencies" v-model="reactTreteForm.selectedCurreny"
            variant="outlined" />

          <div class="custom-label">Vade Tarih </div><br>
          <v-text-field class="text-eureko" :disabled="false" variant="outlined" v-model="reactTreteForm.expiryDate"
            type="date" />
        </v-col>
      </v-row>

      <v-row v-if="ihtiyariSelected">
        <v-col>
          <div class="custom-label">İşlem Tipi </div><br>
          <v-combobox class="custom-combobox" :items="this.processTypes" v-model="reactihtiyariForm.selectedProcessType"
            variant="outlined" />
          <div class="custom-label">İşlem Detay Tipi</div><br>
          <v-combobox class="custom-combobox" :items="this.processDetailTypeS"
            v-model="reactihtiyariForm.selecteProcessDetailType" variant="outlined" />
          <div class="custom-label">Reasürör Şirket</div><br>
          <v-combobox class="custom-combobox" :items="this.reasurorCompanys"
            v-model="reactihtiyariForm.selectedReasurorCompany" variant="outlined" />
          <div class="custom-label">Sigortalı </div><br>
          <v-text-field class="text-eureko" :disabled="false" variant="outlined" v-model="reactihtiyariForm.insured"
            type="number" />
        </v-col>
        <v-col>
          <div class="custom-label">Yıl </div><br>
          <v-text-field class="text-eureko" :disabled="false" variant="outlined" v-model="reactihtiyariForm.year"
            type="number" />
          <div class="custom-label">Quarter</div><br>
          <v-combobox class="custom-combobox" :items="this.quarters" v-model="reactihtiyariForm.selectedQuarter"
            variant="outlined" />
          <div class="custom-label">Hesap Poliçe No </div><br>
          <v-text-field class="text-eureko" :disabled="false" variant="outlined"
            v-model="reactihtiyariForm.damagePolicyNumber" type="number" />
        </v-col>
        <v-col>
          <div class="custom-label">Döviz</div><br>
          <v-combobox class="custom-combobox" :items="this.currenies" v-model="reactihtiyariForm.curreny"
            variant="outlined" />
          <div class="custom-label">Vade Tarihi </div><br>
          <v-text-field class="text-eureko" :disabled="false" variant="outlined" v-model="reactihtiyariForm.expiryDate"
            type="date" />
          <div class="custom-label">Tanzim Tarihi </div><br>
          <v-text-field class="text-eureko" :disabled="false" variant="outlined" v-model="reactihtiyariForm.issueDate"
            type="date" />
        </v-col>
      </v-row>

      <v-row>
        <v-col cols="12" md="12" justify="end" class="text-right">
          <custom-button style="width: 120px;margin-left: 10px" color="info" size="medium" val="Depo"
            @click="repository" />
          <custom-button style="width: 120px;margin-left: 10px" color="secondary" size="medium" val="Yeni Giriş"
            @click="newEntry" />
          <ReasurorModal :isOpen="isModalOpen" @close="closeModal" />
          <custom-button style="width: 120px;margin-left: 10px" color="danger" size="medium" @click="clearFilterForm"
            val="Temizle" />
          <custom-button style="width: 120px;margin-left: 10px" color="primary" size="medium" @click="filter"
            val="Filtrele" />
        </v-col>
      </v-row>
    </v-form>
  </v-container>
</template>
<script>
import CustomButton from "@/components/custom-controller/CustomButton.vue";
import eventBus from '@/plugins/eventBus';
import { ref, watch } from "vue";
import ReasurorModal from "./ReasurorModal.vue";

export default {
  components: {
    CustomButton,
    ReasurorModal
  },
  setup() {
    const repo = ref(["repo", "repo"]);
    const currencies = ref(["USD", "EUR", "GBP", "JPY", "CAD", "AUD", "CHF", "CNY", "NZD", "ZAR", "RUB", "BRL", "INR", "SGD", "SAR"]);
    const banks = ref(["Akbank", "Garanti BBVA", "Halkbank", "İş Bankası", "Türkiye Cumhuriyeti Ziraat Bankası",
    ]);
    const documentTypeItems = ref(['Banka Dekontu', 'Banka Faturas']);
    const reasurorCompanys = ref(["reasurorCompanys", "reasurorCompanys"])
    const quarters = ref(["quarters", "quarters"])
    const processTypes = ref(["processTypes", "processTypes"])
    const processDetailTypeS = ref(["processDetailTypeS", "processDetailTypeS"])
    const isModalOpen = ref(false);
    const treteSelected = ref(true);
    const ihtiyariSelected = ref(false);

    const reactTreteForm = ref({
      selectedProcessType: "",
      selectedReasurorCompany: "",
      year: new Date().getFullYear().toString(),
      selectedQuarter: "",
      selectedCurreny: "",
      expiryDate: new Date().toISOString().substr(0, 10),
    });

    const reactihtiyariForm = ref({
      selectedProcessType: "",
      selecteProcessDetailType: "",
      selectedReasurorCompany: "",
      insured: "",
      year: new Date().getFullYear().toString(),
      selectedQuarter: "",
      damagePolicyNumber: "",
      expiryDate: new Date().toISOString().substr(0, 10),
      issueDate: new Date().toISOString().substr(0, 10)
    });

    const filter = () => {
      if (treteSelected.value) {
        eventBus.emit('reasuror-process-type', 'treteSelected');
      } else if (ihtiyariSelected.value) {
        eventBus.emit('reasuror-process-type', 'ihtiyariSelected');
      }
    };
    const newEntry = () => {
      isModalOpen.value =ref(true);
    }
    const closeModal=()=> {
      isModalOpen.value =ref(false);
    }
    const repository = () => {

    }

    const clearFilterForm = () => {
      reactihtiyariForm.value = {
        selectedProcessType: "",
        selecteProcessDetailType: "",
        selectedReasurorCompany: "",
        insured: "",
        year: "",
        selectedQuarter: "",
        damagePolicyNumber: "",
        expiryDate: new Date().toISOString().substr(0, 10),
        issueDate: ""
      };
      reactTreteForm.value = ref({
        selectedProcessType: "",
        selectedReasurorCompany: "",
        year: "",
        selectedQuarter: "",
        selectedCurreny: "",
        expiryDate: new Date().toISOString().substr(0, 10),
      });
    }
    watch(treteSelected, (newValue) => {
      if (newValue) {
        ihtiyariSelected.value = false;
      }
    });
    watch(ihtiyariSelected, (newValue) => {
      if (newValue) {
        treteSelected.value = false;
      }
    });

    return {
      repo,
      currencies,
      banks,
      documentTypeItems,
      reasurorCompanys,
      quarters,
      processTypes,
      processDetailTypeS,
      reactTreteForm,
      reactihtiyariForm,
      treteSelected,
      ihtiyariSelected,
      isModalOpen,
      closeModal,
      newEntry,
      clearFilterForm,
      filter,
      repository
    };
  },
}
</script>
<style></style>